clang-tools 3.8.0

- Main Page
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Classes | Public Member Functions | List of all members
clang::tidy::readability::FunctionSizeCheck Class Reference

Checks for large functions based on various metrics. More...

`#include <FunctionSizeCheck.h>`

Inheritance diagram for clang::tidy::readability::FunctionSizeCheck:
[legend]
Collaboration diagram for clang::tidy::readability::FunctionSizeCheck:
[legend]

## Public Member Functions
| FunctionSizeCheck (StringRef Name, ClangTidyContext *Context)
void | storeOptions (ClangTidyOptions::OptionMap &Opts) override
| Should store all options supported by this check with their current values or default values for options that haven't been overridden. More...
void | registerMatchers (ast_matchers::MatchFinder *Finder) override
| Override this to register ASTMatchers with `Finder`. More...
void | check (const ast_matchers::MatchFinder::MatchResult &Result) override
| `ClangTidyChecks` that register ASTMatchers should do the actual work in here. More...
void | onEndOfTranslationUnit () override
Public Member Functions inherited from clang::tidy::ClangTidyCheck
| ClangTidyCheck (StringRef CheckName, ClangTidyContext *Context)
| Initializes the check with `CheckName` and `Context`. More...
virtual void | registerPPCallbacks (CompilerInstance &Compiler)
| Override this to register `PPCallbacks` with `Compiler`. More...
DiagnosticBuilder | diag (SourceLocation Loc, StringRef Description, DiagnosticIDs::Level Level=DiagnosticIDs::Warning)
| Add a diagnostic with the check's name. More...

## Additional Inherited Members
Protected Member Functions inherited from clang::tidy::ClangTidyCheck
StringRef | getCurrentMainFile () const
| Returns the main file name of the current translation unit. More...
LangOptions | getLangOpts () const
| Returns the language options from the context. More...
Protected Attributes inherited from clang::tidy::ClangTidyCheck
OptionsView | Options

## Detailed Description

Checks for large functions based on various metrics.

These options are supported:

- `LineThreshold` - flag functions exceeding this number of lines. The default is `-1` (ignore the number of lines).
- `StatementThreshold` - flag functions exceeding this number of statements. This may differ significantly from the number of lines for macro-heavy code. The default is `800`.
- `BranchThreshold` - flag functions exceeding this number of control statements. The default is `-1` (ignore the number of branches).

Definition at line 30 of file FunctionSizeCheck.h.

## Constructor & Destructor Documentation

clang::tidy::readability::FunctionSizeCheck::FunctionSizeCheck | ( | StringRef | Name,
|  | ClangTidyContext * | Context
| ) |  |

Definition at line 19 of file FunctionSizeCheck.cpp.

## Member Function Documentation

void clang::tidy::readability::FunctionSizeCheck::check | ( | const ast_matchers::MatchFinder::MatchResult & | Result | ) |
| override virtual

`ClangTidyChecks` that register ASTMatchers should do the actual work in here.

Reimplemented from clang::tidy::ClangTidyCheck.

Definition at line 44 of file FunctionSizeCheck.cpp.

References SM.

void clang::tidy::readability::FunctionSizeCheck::onEndOfTranslationUnit | ( |  | ) |
| override

Definition at line 70 of file FunctionSizeCheck.cpp.

References clang::tidy::ClangTidyCheck::diag().

void clang::tidy::readability::FunctionSizeCheck::registerMatchers | ( | ast_matchers::MatchFinder * | Finder | ) |
| override virtual

Override this to register ASTMatchers with `Finder`.

This should be used by clang-tidy checks that analyze code properties that dependent on AST knowledge.

You can register as many matchers as necessary with `Finder`. Usually, "this" will be used as callback, but you can also specify other callback classes. Thereby, different matchers can trigger different callbacks.

If you need to merge information between the different matchers, you can store these as members of the derived class. However, note that all matches occur in the order of the AST traversal.

Reimplemented from clang::tidy::ClangTidyCheck.

Definition at line 31 of file FunctionSizeCheck.cpp.

void clang::tidy::readability::FunctionSizeCheck::storeOptions | ( | ClangTidyOptions::OptionMap & | Options | ) |
| override virtual

Should store all options supported by this check with their current values or default values for options that haven't been overridden.

The check should use `Options.store()` to store each option it supports whether it has the default value or it has been overridden.

Reimplemented from clang::tidy::ClangTidyCheck.

Definition at line 25 of file FunctionSizeCheck.cpp.

References clang::tidy::ClangTidyCheck::Options, and clang::tidy::OptionsView::store().

The documentation for this class was generated from the following files:

- FunctionSizeCheck.h
- FunctionSizeCheck.cpp